unofficial mirror of guix-devel@gnu.org 
 help / color / Atom feed
* RUNPATH problem building Rust 1.40.0
@ 2020-06-28 16:12 Matthew Kraai
  2020-06-28 21:04 ` Ludovic Courtès
  0 siblings, 1 reply; 3+ messages in thread
From: Matthew Kraai @ 2020-06-28 16:12 UTC (permalink / raw)
  To: guix-devel

Hi,

I'm trying to package Rust 1.40.0.  Here's the patch I'm testing:

diff --git a/gnu/packages/rust.scm b/gnu/packages/rust.scm
index d139657f39..58515d55e6 100644
--- a/gnu/packages/rust.scm
+++ b/gnu/packages/rust.scm
@@ -1183,4 +1183,23 @@ move around."
                  (generate-all-checksums "vendor")
                  #t)))))))))
 
-(define-public rust rust-1.39)
+(define-public rust-1.40
+  (let ((base-rust
+         (rust-bootstrapped-package rust-1.39 "1.40.0"
+           "1ba9llwhqm49w7sz3z0gqscj039m53ky9wxzhaj11z6yg1ah15yx")))
+    (package
+      (inherit base-rust)
+      (source
+        (origin
+          (inherit (package-source base-rust))
+          (snippet '(begin
+                      (delete-file-recursively "src/llvm-project")
+                      (delete-file-recursively "vendor/jemalloc-sys/jemalloc")
+                      #t))))
+      (arguments
+       (substitute-keyword-arguments (package-arguments base-rust)
+         ((#:phases phases)
+          `(modify-phases ,phases
+             (delete 'remove-unsupported-tests))))))))
+
+(define-public rust rust-1.40)

It currently fails to build with the following error:

/gnu/store/j4zssa8y397q5l2hgkj5svcnj8dlgg32-rust-1.40.0/lib/rustlib/x86_64-unknown-linux-gnu/codegen-backends/librustc_codegen_llvm-llvm.so: error: depends on 'librustc_driver-1040000d6b8afc7f.so', which cannot be found in RUNPATH ("/gnu/store/j4zssa8y397q5l2hgkj5svcnj8dlgg32-rust-1.40.0/lib/rustlib/x86_64-unknown-linux-gnu/codegen-backends/../lib" "/gnu/store/sqpf340l6nnjw33395kmjv97vm8bp8pv-llvm-8.0.0/lib" "/gnu/store/01b4w3m6mp55y531kyi1g8shh722kwqm-gcc-7.5.0-lib/lib/gcc/x86_64-unknown-linux-gnu/7.5.0/../../.." "/gnu/store/fa6wj5bxkj5ll1d7292a70knmyl7a0cr-glibc-2.31/lib")

librustc_driver-1040000d6b8afc7f.so is in
/gnu/store/j4zssa8y397q5l2hgkj5svcnj8dlgg32-rust-1.40.0/lib, which is
not in the RUNPATH.  Does anyone know how I should resolve this?

-- 
Matthew Kraai


^ permalink raw reply	[flat|nested] 3+ messages in thread

* Re: RUNPATH problem building Rust 1.40.0
  2020-06-28 16:12 RUNPATH problem building Rust 1.40.0 Matthew Kraai
@ 2020-06-28 21:04 ` Ludovic Courtès
  2020-07-01  6:15   ` John Soo
  0 siblings, 1 reply; 3+ messages in thread
From: Ludovic Courtès @ 2020-06-28 21:04 UTC (permalink / raw)
  To: Matthew Kraai; +Cc: guix-devel

Hi,

Matthew Kraai <kraai@ftbfs.org> skribis:

> It currently fails to build with the following error:
>
> /gnu/store/j4zssa8y397q5l2hgkj5svcnj8dlgg32-rust-1.40.0/lib/rustlib/x86_64-unknown-linux-gnu/codegen-backends/librustc_codegen_llvm-llvm.so: error: depends on 'librustc_driver-1040000d6b8afc7f.so', which cannot be found in RUNPATH ("/gnu/store/j4zssa8y397q5l2hgkj5svcnj8dlgg32-rust-1.40.0/lib/rustlib/x86_64-unknown-linux-gnu/codegen-backends/../lib" "/gnu/store/sqpf340l6nnjw33395kmjv97vm8bp8pv-llvm-8.0.0/lib" "/gnu/store/01b4w3m6mp55y531kyi1g8shh722kwqm-gcc-7.5.0-lib/lib/gcc/x86_64-unknown-linux-gnu/7.5.0/../../.." "/gnu/store/fa6wj5bxkj5ll1d7292a70knmyl7a0cr-glibc-2.31/lib")
>
> librustc_driver-1040000d6b8afc7f.so is in
> /gnu/store/j4zssa8y397q5l2hgkj5svcnj8dlgg32-rust-1.40.0/lib, which is
> not in the RUNPATH.  Does anyone know how I should resolve this?

I don’t know Rust, but perhaps you could move
librustc_driver-1040000d6b8afc7f.so to
/gnu/store/j4zssa8y397q5l2hgkj5svcnj8dlgg32-rust-1.40.0/lib/rustlib/x86_64-unknown-linux-gnu/codegen-backends/../lib
since that one is in the RUNPATH.

Would be good to check with Rust-savvy people though.  :-)

Ludo’.


^ permalink raw reply	[flat|nested] 3+ messages in thread

* Re: RUNPATH problem building Rust 1.40.0
  2020-06-28 21:04 ` Ludovic Courtès
@ 2020-07-01  6:15   ` John Soo
  0 siblings, 0 replies; 3+ messages in thread
From: John Soo @ 2020-07-01  6:15 UTC (permalink / raw)
  To: Ludovic Courtès; +Cc: guix-devel, Matthew Kraai

[-- Attachment #1: Type: text/plain, Size: 175 bytes --]

Hi Matthew and Ludo,

I’ve been using the rust versions (up to 1.44) from this patch set without issue:

http://issues.guix.gnu.org/40957

Hope that helps,

John


[-- Attachment #2: Type: text/html, Size: 551 bytes --]

^ permalink raw reply	[flat|nested] 3+ messages in thread

end of thread, back to index

Thread overview: 3+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2020-06-28 16:12 RUNPATH problem building Rust 1.40.0 Matthew Kraai
2020-06-28 21:04 ` Ludovic Courtès
2020-07-01  6:15   ` John Soo

unofficial mirror of guix-devel@gnu.org 

Archives are clonable:
	git clone --mirror https://yhetil.org/guix-devel/0 guix-devel/git/0.git

	# If you have public-inbox 1.1+ installed, you may
	# initialize and index your mirror using the following commands:
	public-inbox-init -V2 guix-devel guix-devel/ https://yhetil.org/guix-devel \
		guix-devel@gnu.org
	public-inbox-index guix-devel

Example config snippet for mirrors

Newsgroups are available over NNTP:
	nntp://news.yhetil.org/yhetil.gnu.guix.devel
	nntp://news.gmane.io/gmane.comp.gnu.guix.devel


AGPL code for this site: git clone https://public-inbox.org/public-inbox.git